//---------------------------------------------------------------------------

#ifndef MandelbrotMainH
#define MandelbrotMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <jpeg.hpp>
#include <ImgList.hpp>
#include <Dialogs.hpp>
#include "SmartImage.h"
#include <ExtDlgs.hpp>
#include <Menus.hpp>
#include <ActnList.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
  TToolBar *ToolBar1;
  TTimer *Timer1;
  TToolButton *tbDraw;
  TStatusBar *StatusBar1;
	TImageList *ImageList1;
	TPanel *pnImagePanel;
  TToolButton *tbSave;
  TSaveDialog *SaveDialog1;
  TToolButton *tbNew;
  TToolButton *tbClose;
  TToolButton *tbOpen;
  TOpenPictureDialog *OpenPictureDialog1;
  TGroupBox *GroupBox2;
  TSplitter *Splitter1;
  TGroupBox *GroupBox1;
  TTreeView *tvImages;
  TPopupMenu *pmTreeLevel;
  TMenuItem *pmiCloseAll;
  TMenuItem *pmiMinAll;
  TMenuItem *pmiFullSizeAll;
  TMenuItem *pmiCascade;
  TMenuItem *pmiTile;
  TMenuItem *pmiCollapse;
  TMenuItem *pmiExpand;
  TPopupMenu *pmPicNode;
  TMenuItem *pmiClose;
  TMenuItem *pmiMinimize;
  TMenuItem *pmiUpperLeft;
  TActionList *aclActionList;
  TAction *acNew;
  TAction *acOpenPic;
  TAction *acClose;
  TAction *acMinimize;
  TAction *acCloseAll;
  TAction *acMinimizeAll;
  TAction *acMax;
  TAction *acMaxAll;
  TAction *acCascade;
  TAction *acTile;
  TAction *acCollapse;
  TAction *acExpand;
  TAction *acToggleMode;
  TAction *acUpperLeft;
  TAction *acAssignImage;
  TAction *acClearImage;
  TAction *acSave;
  TAction *acDraw;
  TAction *acRedraw;
  TMenuItem *pmiDraw;
  TMenuItem *pmiSave;
  TMenuItem *pmiClear;
  TGroupBox *GroupBox3;
  TImage *Image1;
  TAction *acScaleUP;
  TAction *acScaleDn;
  TMenuItem *ScaleUp1;
  TMenuItem *ScaleDown1;
	TPanel *Panel2;
	TCheckBox *CheckBox1;
	TLabel *Label2;
	TLabel *Label1;
  TStatusBar *StatusBar2;
  TAction *acOffsetUp;
  TAction *acOffsetDown;
  TAction *acOffsetLeft;
  TAction *acOffsetRight;
  TMenuItem *OffsetUp1;
  TMenuItem *OffsetDown1;
  TMenuItem *OffsetLeft1;
  TMenuItem *OffsetRight1;
  TAction *acUseCoord;
  TAction *acUseIconBox;
  TMenuItem *IconBox1;
  TMenuItem *Coordinates1;
  TAction *acUseColor;
  TMenuItem *Color1;
  TToolButton *ToolButton1;
  TAction *acSaveAll;
  TToolButton *tbSaveAll;
	TAction *acSaveIcon;
	TAction *acCopyIcon;
	TToolButton *tbRed;
	TToolButton *tbGreen;
	TToolButton *tbBlue;
  void __fastcall tbSaveClick(TObject *Sender);
  void __fastcall tbNewClick(TObject *Sender);
  void __fastcall tvImagesMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
  void __fastcall acDrawExecute(TObject *Sender);
  void __fastcall acScaleUPExecute(TObject *Sender);
  void __fastcall acScaleDnExecute(TObject *Sender);
  void __fastcall Image1Progress(TObject *Sender, TProgressStage Stage,
          BYTE PercentDone, bool RedrawNow, const TRect &R,
          const AnsiString Msg);
  void __fastcall acOffsetRightExecute(TObject *Sender);
  void __fastcall acOffsetLeftExecute(TObject *Sender);
  void __fastcall acOffsetUpExecute(TObject *Sender);
  void __fastcall acOffsetDownExecute(TObject *Sender);
  void __fastcall acSaveExecute(TObject *Sender);
  void __fastcall acUseIconBoxExecute(TObject *Sender);
  void __fastcall acUseCoordExecute(TObject *Sender);
  void __fastcall acUseColorExecute(TObject *Sender);
  void __fastcall acMinimizeExecute(TObject *Sender);
  void __fastcall acMaxExecute(TObject *Sender);
  void __fastcall acCloseExecute(TObject *Sender);
  void __fastcall acCloseAllExecute(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall acSaveAllExecute(TObject *Sender);
	void __fastcall tbRedClick(TObject *Sender);
	void __fastcall tbGreenClick(TObject *Sender);
	void __fastcall tbBlueClick(TObject *Sender);
private:	// User declarations
  Graphics::TBitmap *mbBitmap;
	Graphics::TBrush *mbBrush;
	TImage *mbImage;

	TStringList *ImageSList;
	TSmartImage *CurrImage;

  TTreeNode *IRootNode;
  TTreeNode *KRootNode;
  TTreeNode *SRootNode;


  AnsiString PicName;
  AnsiString PicPath;
  AnsiString SchemaFileName;
	AnsiString mbPath;
	AnsiString mbFileName;
  AnsiString pnFilename;
	AnsiString mbName;

  float Scale;
	int RangeX;
	int RangeY;
  int Iter;
	int color[1024][1024];
	int xOS;
	int yOS;
	TColor PixColor;
  int MouseMode;
  int xLast;
  int yLast;
  bool mbCanClose;


	void __fastcall ShiftColor(void);
  void __fastcall ShiftColorPanel();
  void __fastcall RefreshSelState(void);
  void __fastcall Deselect(void);
  void __fastcall ActionUpdate(void);
  void __fastcall DelAll(void);


public:		// User declarations
  __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
